/*

 Cipher-.H - Decipher Data Function

extern int Decipher(char *xSource, char *xTarget, char *Input_Key)

*/

extern int Decipher(char *xSource, char *xTarget, char *Input_Key)
{
	char LocalTemp[257] = {'\0'};
	int EndOfFile  = 0;
	char CharBuffer = '\0';
	short KeyLength = 0;
	DWORD SourceFileSize = 0;
	long double Current_Size  = 0;

	SourceFileSize = FileSize(xSource);
	if(SourceFileSize == -1)
	{
		Error("File Size Error. Error 8.");
		DoneFlag = 1;
		CleanUp(0,1);
		return(0);
	}

	FILE *Source;
	FILE *Target;

	if((Source = fopen(xSource,"rb")) == NULL)
	{
		Error("Could Not Open Source File For Read. Error: 9");
		if(Source)fclose(Source);
		return 0;
	}


	End_Of_File = 0;

	fseek(Source,0,SEEK_SET);

	fread(LocalTemp,sizeof(char),2,Source); // Get KeyLength
	KeyLength = CharInt(LocalTemp);
	Current_Size += 2;
	Current_Size += KeyLength;

	fseek(Source,3,SEEK_SET); // Set File Position To Third Byte

	fread(Password,sizeof(char),KeyLength,Source); // Get Key
	if(strcmp(Password,Input_Key) != 0)
	{
		Status = "The Password You Entered Is Incorrect!";
		if(Source)fclose(Source);
		return 0;
	}
	fseek(Source,1,SEEK_CUR);
	Current_Size += 1;

	if((Target = fopen(xTarget,"wb")) == NULL)
	{
		Error("Could Not Open Target File For Write. Error: 10");
		if(Source)fclose(Source);
		if(Target)fclose(Target);
		return 0;
	}

	EndOfFile = 1; /* not EOF */
	while(EndOfFile != EOF)
	{
		if(CancelFlag)
		{
			if(Target)fclose(Target);
			if(Source)fclose(Source);
			CancelProcess();
			return 0;
		}
		EndOfFile = fscanf(Source, "%c", &CharBuffer);
		if(EndOfFile != EOF) fprintf(Target, "%c", CharBuffer - 128);
		Current_Size++;
		StatusValue = ((Current_Size / SourceFileSize) * 100);
	}

	if(Source)fclose(Source);
	if(Target)fclose(Target);

	return 1;
}
/////////////////////////////////////////////////////////////////////

