
extern int PasswordDialog (HWND hDlg, int Msg, int wParam, int lParam)
{
	static HWND SystemMenu;
	static HWND PasswordBitStatus;
	static HWND EffeciencyBits_hWnd;
	static HWND PasswordEdit_hWnd;
	static HWND InfoTextStatic_hWnd;

	float PasswordLen = 0;
	float PasswordBits = 0;
	float EffeciencyBits = 0;

	char LocalTemp[257];

	DWORD TopMost = 0;

	for(;;)
	{
		if(Msg==WM_INITDIALOG)
		{
			PasswordDialog_hWnd = hDlg;

			if(GetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\PasswordDialog","TopMost",TopMost))
			{
				if(TopMost == 1)
				{
					CheckDlgButton(PasswordDialog_hWnd, 105, BST_CHECKED);
					SetWindowPos(PasswordDialog_hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
				}
			}
			else{
					SetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\PasswordDialog","TopMost",1);
					CheckDlgButton(PasswordDialog_hWnd, 105, BST_CHECKED);
					SetWindowPos(PasswordDialog_hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
			}

			SystemMenu = GetSystemMenu(PasswordDialog_hWnd,FALSE);
			AppendMenu(SystemMenu,MF_SEPARATOR,0,0);
			AppendMenu(SystemMenu,MF_STRING,VersionInfo,"Version");

			SendMessage(PasswordDialog_hWnd, WM_SETICON, TRUE,(LPARAM)LoadIcon(GetWindowInstance(PasswordDialog_hWnd), MAKEINTRESOURCE(1)));
			SendMessage(PasswordDialog_hWnd, WM_SETTEXT, FALSE,(LPARAM)TitleCaption);

			CenterWindow(PasswordDialog_hWnd);

			PasswordBitStatus = GetDlgItem(PasswordDialog_hWnd,1000);
			EffeciencyBits_hWnd = GetDlgItem(PasswordDialog_hWnd,2000);

			InfoTextStatic_hWnd = GetDlgItem(PasswordDialog_hWnd,101);
			PasswordEdit_hWnd = GetDlgItem(PasswordDialog_hWnd,500);

			SetTimer(PasswordDialog_hWnd,1,1000,NULL);

			if(Encrypt)
			{
				SetText(InfoTextStatic_hWnd,"Enter A Password To Be Used To Encrypt This Data");
			}

			if(Decrypt)
			{
				SetText(InfoTextStatic_hWnd,"Enter The Password That Was Used To Encrypt This Data.");
			}

			if(Pack)
			{
				SetText(InfoTextStatic_hWnd,"Enter A Password To Be Used To Pack This Data.");
			}

			if(Unpack)
			{
				SetText(InfoTextStatic_hWnd,"Enter The Password That Was Used To Pack This Data.");
			}

			if(Encrypt || Pack)
			{
				EnableWindow(PasswordBitStatus,TRUE);
				EnableWindow(EffeciencyBits_hWnd,TRUE);
				EnableWindow(GetDlgItem(PasswordDialog_hWnd,1500),TRUE);
			}

			break;
		}
		//----------------------------------------------------------------------

		if(Msg == 307) // Key Down
		{

			PasswordLen = strlen(GetText(PasswordEdit_hWnd));

			if(PasswordLen >= 4)EnableWindow(GetDlgItem(PasswordDialog_hWnd,103),TRUE);
			if(PasswordLen <  4)EnableWindow(GetDlgItem(PasswordDialog_hWnd,103),FALSE);

			if(Encrypt || Pack)
			{
				PasswordBits = (PasswordLen * 8); /* 8-Bits Per Character*/
				EffeciencyBits = (PasswordLen / 70) * 100;

				SendMessage(PasswordBitStatus, PBM_SETPOS,EffeciencyBits,0);

				sprintf(LocalTemp,"(%.0f Bits)",PasswordBits);
				SetText(EffeciencyBits_hWnd,LocalTemp);
			}

		}

		if(Msg==WM_COMMAND)
		{

			if(wParam==105) // Always On Top
			{
				if(IsDlgButtonChecked(PasswordDialog_hWnd, 105))
				{
					SetWindowPos(PasswordDialog_hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
					SetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\PasswordDialog","TopMost",1);
					SetFocus(PasswordEdit_hWnd);
				}
				else{
					SetWindowPos(PasswordDialog_hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
					SetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\PasswordDialog","TopMost",0);
					SetFocus(PasswordEdit_hWnd);
				}
			}

			if(wParam==102) // Help
			{
				char HelpFile[1024];
				unsigned long SizeOfHelpFile = sizeof(HelpFile);
				GetStringValue(HKEY_CLASSES_ROOT,"128File\\AppInfo","HelpPath",HelpFile,SizeOfHelpFile);
				if(FAccess(HelpFile,0))
				{
					SetWindowPos(PasswordDialog_hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
					CheckDlgButton(PasswordDialog_hWnd, 105, BST_UNCHECKED);
					ShellExecute(PasswordDialog_hWnd,"open",HelpFile,"","",SW_MAXIMIZE);
				}
				else{
					MessageBox(PasswordDialog_hWnd, "Help File Not Found. Please Reinstall 128Gamma. \r\n If You Have Further Trouble Contact NetWorkDLS : Info@NetWorkDLS.Com Or Visit www.NetWorkDLS.com" ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL);
				}
				SetFocus(PasswordEdit_hWnd);
			}

			if(wParam==103) // Ok
			{
				CodedKey = GetText(PasswordEdit_hWnd);

				if(Encrypt) //Encrypt
				{
					Update_LastUsed();
					ShowWindow(PasswordDialog_hWnd,FALSE);
					EncryptProcess_Thread_Handle = CreateThread(NULL,0,EncryptProcess_Thread,(LPVOID)0,0,&EncryptProcess_Thread_ID);
				}

				if(Decrypt) //Decrypt
				{
					Update_LastUsed();
					ShowWindow(PasswordDialog_hWnd,FALSE);
					DecryptProcess_Thread_Handle = CreateThread(NULL,0,DecryptProcess_Thread,(LPVOID)0,0,&DecryptProcess_Thread_ID);
				}

				if(Pack) //PackFiles
				{
					Update_LastUsed();
					ShowWindow(PasswordDialog_hWnd,FALSE);
					PackProcess_Thread_Handle = CreateThread(NULL,0,PackProcess_Thread,(LPVOID)0,0,&PackProcess_Thread_ID);
				}

				if(Unpack) //UnpackFiles
				{
					Update_LastUsed();
					ShowWindow(PasswordDialog_hWnd,FALSE);
					UnpackProcess_Thread_Handle = CreateThread(NULL,0,UnpackProcess_Thread,(LPVOID)0,0,&UnpackProcess_Thread_ID);
				}

				if(!Pack)StatusDialog_Thread_Handle = CreateThread(NULL,0,StatusDialog_Thread,(LPVOID)0,0,&StatusDialog_Thread_ID);
			}

			if(wParam == 104) //Cancel
			{
				if(Pack)unlink(GlobalFileName);
				CleanUp(0,1);
				EndDialog(PasswordDialog_hWnd,0);
			}

			if(wParam==106) //Open About Dialog
			{
				ShowWindow(PasswordDialog_hWnd,FALSE);
				DialogBox(hInstance,MAKEINTRESOURCE(1000),PasswordDialog_hWnd,AboutDialog);
				ShowWindow(PasswordDialog_hWnd,TRUE);
				SetFocus(PasswordEdit_hWnd);
			}
			break;
		}

		if(Msg == WM_TIMER)
		{
			if(Verifiy)
			{
				CleanUp(0,1);
				EndDialog(PasswordDialog_hWnd,0);
				if(CancelFlag && Pack)unlink(GlobalFileName);
				if(!DoneFlag)DoneFlag = 1;
			}
		}

		if(Msg == WM_SYSCOMMAND)
		{
			if(LOWORD(wParam) == VersionInfo)
			{
				MessageBox(PasswordDialog_hWnd, GammaVersion, TitleCaption, 0 + MB_ICONASTERISK + MB_TASKMODAL);
			}
		}

		if(Msg == WM_CLOSE) //Close Dialog
		{
			if(Pack)unlink(GlobalFileName);
			CleanUp(0,1);
			EndDialog(PasswordDialog_hWnd,0);
		}

		break;
	}
	return 0;
}

