

extern int StatusDialog (HWND hDlg, int Msg, int wParam, int lParam)
{
	static HWND StatusText_hWnd = 0;
	static HWND StatusBar_hWnd = 0;

	DWORD TopMost = 0;
	int LastValue = 0;

	for(;;)
	{
		if(Msg==WM_INITDIALOG)
		{
			StatusDialog_hWnd = hDlg;

			SendMessage(StatusDialog_hWnd, WM_SETTEXT, FALSE,(LPARAM)TitleCaption);
			SendMessage(StatusDialog_hWnd, WM_SETICON, TRUE,(LPARAM)LoadIcon(GetWindowInstance(AboutDialog_hWnd), MAKEINTRESOURCE(1)));

			if(GetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\StatusDialog","TopMost",TopMost))
			{
				if(TopMost == 1)
				{
					CheckDlgButton(StatusDialog_hWnd, 102, BST_CHECKED);
					SetWindowPos(StatusDialog_hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
				}
			}
			else{
					SetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\StatusDialog","TopMost",1);
					CheckDlgButton(StatusDialog_hWnd, 102, BST_CHECKED);
					SetWindowPos(StatusDialog_hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
			}

			SetTimer(StatusDialog_hWnd,0,10,NULL);

			StatusBar_hWnd = GetDlgItem(StatusDialog_hWnd, 1000);
			StatusText_hWnd = GetDlgItem(StatusDialog_hWnd,100);

			SendMessage(StatusBar_hWnd, PBM_SETPOS,0,0);
			CenterWindow(StatusDialog_hWnd);

			break;
		}
		//----------------------------------------------------------------------

		if(Msg==WM_COMMAND)
		{

			if(wParam==102) // Always On Top
			{
				if(IsDlgButtonChecked(StatusDialog_hWnd, 102))
				{
					SetWindowPos(StatusDialog_hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
					SetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\StatusDialog","TopMost",1);
				}
				else{
					SetWindowPos(StatusDialog_hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
					SetDWORDValue(HKEY_CLASSES_ROOT,"128File\\AppInfo\\StatusDialog","TopMost",0);
				}
			}

			if(wParam == 101)
			{
				if(DoneFlag)
				{
					Verifiy = 1;
					KillTimer(StatusDialog_hWnd,0);
					EndDialog(StatusDialog_hWnd,0);
					break;
				}
				else
					{
						CancelFlag = 1;
						Status = "Please Wait...";
						EnableWindow(GetDlgItem(StatusDialog_hWnd,101),FALSE);
						break;
					}
			}
		}

		if(Msg == WM_TIMER)
		{
			if(KillFlag)
			{
				KillTimer(StatusDialog_hWnd,0);
				EndDialog(StatusDialog_hWnd,0);
			}

			{ // Status Bar Handler (Begin)
				if(LastValue != StatusValue)
				{
					LastValue = StatusValue;
					SendMessage(StatusBar_hWnd, PBM_SETPOS,StatusValue,0);
				}
			} // Status Bar Handler (End)

			if(DoneFlag)
			{
				ShowWindow(StatusDialog_hWnd,TRUE);
				if(CancelFlag)Status = "Canceled!";
				SetText(GetDlgItem(StatusDialog_hWnd,101),"Ok");
				EnableWindow(GetDlgItem(StatusDialog_hWnd,101),TRUE);
				MessageBeep(MB_ICONASTERISK);
				KillTimer(StatusDialog_hWnd,0);
			}

			if(strlen(Status) > 0)
			{
				SetText(StatusText_hWnd,Status);
				Status = "";
			}
			break;
		}

		break;
	}
	return 0;
}

